<?php

namespace Drupal\entity_reference_delete_check\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Url;

/**
 * This event encapsulates an entity and a URL to it.
 *
 * This is used so that a URL to the place where an entity is used can be provided to the user during the delete check.
 */
class DeleteCheckEntityUrlEvent extends Event {

  public readonly EntityInterface $entity;

  private ?Url $url = NULL;

  public function __construct(EntityInterface $entity) {
    $this->entity = $entity;
  }

  public function getUrl(): ?Url {
    return $this->url;
  }

  public function setUrl(?Url $url): void {
    $this->url = $url;
  }

}
