<?php

namespace Drupal\entity_reference_delete_check\EventSubscriber;

use Drupal\entity_reference_delete_check\Event\DeleteCheckEntityUrlEvent;
use Exception;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
 * This event subscriber provides entity URLs for entities implementing {@see \Drupal\Core\Entity\EntityInterface::toUrl}.
 */
class DeleteCheckEntityUrlEventSubscriber implements EventSubscriberInterface {

  public static function getSubscribedEvents(): array {
    return [
      DeleteCheckEntityUrlEvent::class => 'setUrl',
    ];
  }

  public function setUrl(DeleteCheckEntityUrlEvent $event): void {
    $entity = $event->entity;
    try {
      $event->setUrl($entity->toUrl());
    } catch (Exception) {
      // can't get the entity url, let some other cunt get it
    }
  }

}
